Book a Demo!
CoCalc Logo Icon
StoreFeaturesDocsShareSupportNewsAboutPoliciesSign UpSign In
freebsd
GitHub Repository: freebsd/freebsd-ci
Path: blob/main/scan-build/scan-world-cron
1130 views
#!/bin/sh

# Copyright (c) 2011-2014 Ulrich Spoerlein <[email protected]>
# Copyright (c) 2014-2015 Li-Wen Hsu <[email protected]>
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.

today="`date +%Y-%m-%d`"
buildlog="$today-`uname -p`.log"

cd /data/scan-build/freebsd-head && scan-world >$buildlog 2>&1

if [ $? != 0 ]; then
    echo "Error during scan-world" >&2
    tail -100 $buildlog | mail -s"scan-world error" [email protected]
    exit 1
fi

count=`egrep '^scan-build: [0-9]+ bugs found\.' $buildlog | awk '{sum+=$2} END{print sum}'`
notfound=`egrep -c 'No such file or directory' $buildlog`
dontknow=`egrep -c 'don.t know how to make' $buildlog`

if [ -z "$count" ] || [ ! "$count" -gt 0 ]; then
    echo "Error during scan-world, no bugs found" >&2
    tail -100 $buildlog | mail -s"scan-world error" [email protected]
    exit 1
fi

[ -n "$count" ] && echo "<div id=\"left\">$today</div><div id=\"center\">$count potential bugs found</div><div id=\"clear\"></div>" >> HEADER.html

( echo "Updated #FreeBSD and #llvm #clang scan-build results at http://scan.freebsd.your.org/freebsd-head claiming $count bugs found"
  echo "notfound=$notfound dontknow=$dontknow date=$today"
  df -m /data/scan-build
) | mail -s"`hostname` finished scan-world" [email protected]